semgrep:
  image: semgrep/semgrep
  script:
    - echo "Running Semgrep..."
    - start_time=$(date +%s)
    - semgrep ci --json > semgrep-output-raw.json
    - python -c 'import json; data = json.load(open("semgrep-output-raw.json")); print(json.dumps(data, indent=2))' > semgrep-output.json
    - end_time=$(date +%s)
    - execution_time=$((end_time - start_time))
    - minutes=$((execution_time / 60))
    - seconds=$((execution_time % 60))
    - formatted_time="${minutes} minutes and ${seconds} seconds"
    - python generate_html_report.py semgrep-output.json semgrep-output.html "Zenotta Project" "$formatted_time"
    - ls -lh  # List files to verify if semgrep-output.html exists and its size 
  artifacts:
    paths:
      - semgrep-output.json
      - semgrep-output.html
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  variables:
    SEMGREP_APP_TOKEN: $SEMGREP_APP_TOKEN
